/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA - www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
var app = angular.module('lssApp', ['ngSanitize', 'ui.bootstrap', 'ngRoute', 'ngAnimate',
    'toaster', 'ngDropdowns', 'angular.filter','dndLists',
    'ui.grid', 'ui.grid.selection', 'ui.grid.edit',
    'ui.grid.pagination', 'nvd3', 'dialogservices']);

app.filter('startFrom', function () {
    return function (input, start) {
        if (input) {
            start = +start; //parse to int
            return input.slice(start);
        }
        return [];
    };
});
app.filter('NoPID', function() {
    return function( items ) {
        var filtered = [];
        angular.forEach(items, function(item) {
            var i = 0;
            angular.forEach(items, function(item2) {
                if( item.PID === item2.GID ) { i=1; }                
              });
            if(i==0){ filtered.push(item); }
        });
        return filtered;
    };
});
app.filter('UniqueTheater', function(){
    return function( items ) {
        var filtered = [];
        var i = 0;
        angular.forEach(items, function(item) {
            i=0;
            angular.forEach(filtered, function(item2) {
                if( item.TheaterNumber === item2.TheaterNumber && item.OrgKey===item2.OrgKey ) { i=1; }
            });
            if(i===0){ filtered.push(item); }
        });
        return filtered;
    };
});    

app.config(['$locationProvider', function($locationProvider) {
    $locationProvider.html5Mode(true);
}]);

app.config(['$routeProvider', function ($routeProvider) {
        $routeProvider
                .when('/login', {
                    templateUrl: 'partials/login.html',
                    controller: 'authCtrl'
                })
                .when('/logout', {
                    templateUrl: 'partials/logout.html',
                    controller: 'authCtrl'
                })
                .when('/signup', {
                    templateUrl: 'partials/signup.html',
                    controller: 'authCtrl'
                })
                .when('/theaters', {
                    templateUrl: 'partials/theaters.html',
                    controller: 'lssDataDisplayController'
                })
                .when('/groups', {
                    templateUrl: 'partials/Groups.html'
                    //controller: 'GroupController'
                })
                .when('/screens', {
                    templateUrl: 'partials/screens.html',
                    controller: 'ScreenController'
                })
                .when('/notifications', {
                    templateUrl: 'partials/notifications.html',
                    controller: 'notificationController'
                })
                .when('/adduser', {
                    templateUrl: 'partials/adduser.html',
                    controller: 'addUserController'
                })
                .when('/modifyuser', {
                    templateUrl: 'partials/modifyuser.html',
                    controller: 'modifyUserController'
                })
                .when('/modifygroups', {
                    templateUrl: 'partials/modifygroups.html',
                    controller: 'modifyGroupsController'
                })
                .when('/newcompany', {
                    templateUrl: 'partials/newcompany.html',
                    controller: 'newCompanyController'
                })
                .when('/adminreports', {
                    templateUrl: 'partials/adminreports.html'
                    //controller: 'AdministrationReportController'
                })
                .when('/lssconfiguration', {
                    templateUrl: 'partials/lssconfiguration.html'
                    //controller: 'LSSConfigurationController'
                })
                .when('/displaysettings', {
                    templateUrl: 'partials/displaysettings.html',
                    controller: 'DisplaySettingsController'
                })
                .when('/dbadmin', {
                    templateUrl: 'partials/dbadmin.html',
                    controller: 'dbAdminController'
                })
                .when('/mailadmin', {
                    templateUrl: 'partials/mailadmin.html',
                    controller: 'mailAdminController'
                })
                .when('/notificationsadmin', {
                    templateUrl: 'partials/notificationsAdmin.html',
                    controller: 'notificationAdminController'
                })
                .when('/dashboard', {
                    title: 'Dashboard',
                    templateUrl: 'partials/dashboard.html',
                    controller: 'authCtrl'
                })
                .when('/', {
                    title: 'Login',
                    templateUrl: 'partials/login.html',
                    controller: 'authCtrl',
                    role: '0'
                })
                .otherwise({
                    title: 'Login',
                    templateUrl: 'partials/login.html',
                    controller: 'authCtrl'
                });
    }]);

// App pre-start functionality
// Generate parameters from the Get Variables in the location string.
// Load the cached data before the app starts.
app.run(function (getParametersFactory,configurationFactory,$location) {
    $.cookie.json = true;
    jQuery.extend(configurationFactory,$.cookie("Settings"));
    jQuery.extend(getParametersFactory, $location.search());
    if('startdate' in $location.search() && 'enddate' in $location.search()){
        getParametersFactory['enddate'] = new Date(parseInt(getParametersFactory['enddate']));
        getParametersFactory['startdate'] = new Date(parseInt(getParametersFactory['startdate']));
    }
    else{
        // Create a date for midnight today.
        d = new Date();
        ds = d.toLocaleDateString();
        d = new Date(ds); 
        // Range the user view from the DateRange setting before today, through tonight at midnight
        // If a user is using the web app around midnight, they may not see data submitted after midnight until they reload the page.
        getParametersFactory['enddate'] = new Date(d.getTime()+86399999);
        getParametersFactory['startdate'] = new Date(d.getTime() - configurationFactory.DateRange);
    }
    getParametersFactory['screen'] = getParametersFactory['screen'].toString();
    getParametersFactory['theater'] = getParametersFactory['theater'].toString();
    if (getParametersFactory['loc'] !== undefined) {
        $location.path(getParametersFactory['loc']);
    }
    console.log("Location - "+$location.$$absUrl);
});
app.run(function ($rootScope, $location, Data, getParametersFactory) {
    $rootScope.$on("$routeChangeStart", function (event, next, current) {
        console.log("$routeChangeStart - Authentication");
        $rootScope.authenticated = false;
        Data.get('session').then(function (results) {
            if (results.UID) {
                $rootScope.authenticated = true;
                $rootScope.UID = parseInt(results.UID);
                $rootScope.UserName = results.UserName;
                $rootScope.Email = results.Email;
                $rootScope.Level = parseInt(results.Level);
                $rootScope.Company = results.Company;
                $rootScope.CID = results.CID;
                
                // Indicate the user level for a successful login.
                switch($rootScope.Level)
                {
                    case EnumUserLevels.ADMIN:
                        $rootScope.UserTypeAuthenticated = 'Administrator Authentication';
                        break;
                    case EnumUserLevels.MANAGER:
                        $rootScope.UserTypeAuthenticated = 'Manager Authentication';
                        break;
                    default:
                        $rootScope.UserTypeAuthenticated = 'User Authentication';
                        break;
                }
                
                if(!('orgkey' in getParametersFactory)){
                    getParametersFactory['orgkey'] = results.Company;
                }
                if (next.$$route.originalPath === '/' || next.$$route.originalPath === '/login') {
                    $location.path("/dashboard");
                }
            } else {
                var nextUrl = next.$$route.originalPath;
                if (nextUrl === '/signup' || nextUrl === '/login') {

                } else {
                    $location.path("/login");
                }
            }
        });
    });
});

angular.module('lssApp').directive('datepickerPopup', function (dateFilter, datepickerPopupConfig) {
    return {
        restrict: 'A',
        priority: 1,
        require: 'ngModel',
        link: function(scope, element, attr, ngModel) {
            var dateFormat = attr.datepickerPopup || datepickerPopupConfig.datepickerPopup;
            ngModel.$formatters.push(function (value) {
                return dateFilter(value, dateFormat);
            });
        }
    };
});

// Required for Signup, Add User and Modify User
app.directive('passwordMatch', [function () {
    return {
        restrict: 'A',
        scope:true,
        require: 'ngModel',
        link: function (scope, elem , attrs,control) {
            var checker = function () {
                var e1 = scope.$eval(attrs.ngModel);
                var e2 = scope.$eval(attrs.passwordMatch);
                if(e2!=null)
                return e1 == e2;
            };
            scope.$watch(checker, function (n) {
                control.$setValidity("passwordNoMatch", n);
            });
        }
    };
}]);
