/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
app.controller('authCtrl', function ($scope, $rootScope, $routeParams, $location, $http, Data, getParametersFactory) {
    //initially set those objects to null to avoid undefined error
    $scope.login = {};
    $scope.signup = {};    
    $scope.getParameters = getParametersFactory;
    
    //-----------------------------------------------------------------------
    // doLogin
    // 
    //-----------------------------------------------------------------------
    $scope.doLogin = function (customer) {
        Data.post('login', {
            customer: customer
        }).then(function (results) {
            Data.toast(results);
            if (results.status === "success") {
                $scope.login = true;
                if ($scope.getParameters['loc'] === undefined || $scope.getParameters['loc'] === '/login') {
                    $scope.getParameters.loc = '/dashboard';
                }
                $location.path($scope.getParameters.loc);
            }
        });
    };
    
    $scope.signup = {Email: '', Password: '', UserName: '', Phone: '',
                     Level: EnumUserLevels.USER, NotificationType: EnumNotifyLevels.NONE};
                 
    //-----------------------------------------------------------------------
    // signUp
    // 
    //-----------------------------------------------------------------------
    $scope.signUp = function (customer) {
        Data.post('signUp', {
            customer: customer
        }).then(function (results) {
            Data.toast(results);
            if (results.status === "success") {
                $location.path('dashboard');
            }
        });
    };
    
    $scope.modifyUser = function (customer) {
        Data.post('modifyUser', {
            customer: customer
        }).then(function (results) {
            Data.toast(results);
            if (results.status === "success") {
                $location.path('modifyuser');
            }
        });
    };
    
    $scope.logout = function () {
        Data.get('logout').then(function (results) {
            $scope.login = false;
            $rootScope.Level = EnumUserLevels.USER;
            Data.toast(results);
            $location.path('login');
        });
    };
    
    //-----------------------------------------------------------------------
    // User Level
    // 
    // Create a list for user access levels
    //-----------------------------------------------------------------------
    $scope.userLevels = [
        {
            text: 'User',
            value: EnumUserLevels.USER
        }, {
            text: 'Manager',
            value: EnumUserLevels.MANAGER
        }, {
            text: 'Administrator',
            value: EnumUserLevels.ADMIN
        }
    ];
    
    // Always an administrator
    $scope.signup.UserLevel = EnumUserLevels.None;

    //-----------------------------------------------------------------------
    // Notification Levels
    // 
    // Create a list of items for the dropdown.
    //-----------------------------------------------------------------------
    $scope.notifyLevels = [
        {
            text: 'None',
            value: EnumNotifyLevels.NONE
        }, {
            text: 'Errors Only',
            value: EnumNotifyLevels.ERRORSONLY
        }, {
            text: 'All',
            value: EnumNotifyLevels.ALL
        }
    ];
    
    // Initialize with the default selection
    $scope.signup.NotificationType = EnumNotifyLevels.NONE;
    
    
    
    
});