/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// DisplaySettingsController
//
// This controller is the backbone for the display settings and configuration.
// Here the user will change the settings for how the LSS Server pages are
// displayed.  The controller will save these to cookies so that they can be
// reloaded when the page first comes up.
//---------------------------------------------------------------------------
app.controller('DisplaySettingsController', function ($scope, $timeout, configurationFactory, getParametersFactory) {
    $scope.settings = configurationFactory;
    $scope.parameters = getParametersFactory;
    $scope.dt = new Date();
    $scope.delimeter = 'dash';
    $scope.olddelimeter = 'dash';
    $scope.dtfFormats = {
        dash: [ 'EEE MMMM dd, yyyy','EEE MMM dd, yyyy','MMM dd, yyyy',
                'dd MMM yyyy','yyyy-MM-dd','dd-MM-yyyy','MM-dd-yyyy'],
        slash:[ 'EEE MMMM dd, yyyy','EEE MMM dd, yyyy','MMM dd, yyyy',
                'dd MMM yyyy','yyyy/MM/dd','dd/MM/yyyy','MM/dd/yyyy'],
        dot:  [ 'EEE MMMM dd, yyyy','EEE MMM dd, yyyy','MMM dd, yyyy',
                'dd MMM yyyy','yyyy.MM.dd','dd.MM.yyyy','MM.dd.yyyy']
    };
    $scope.graphdtfFormats = {
        dash: [ '%a %B %d, %Y','%a %b %d, %Y','%b %d, %Y',
                '%d %b %Y','%Y-%m-%d','%d-%m-%Y','%m-%d-%Y'],
        slash:[ '%a %B %d, %Y','%a %b %d, %Y','%b %d, %Y',
                '%d %b %Y','%Y/%m/%d','%d/%m/%Y','%m/%d/%Y'],
        dot:  [ '%a %B %d, %Y','%a %b %d, %Y','%b %d, %Y',
                '%d %b %Y','%Y.%m.%d','%d.%m.%Y','%m.%d.%Y']
    };
    $scope.opened = false;
    $scope.showtime = false;
    $scope.showtimezone = false;
    if($scope.settings.DateFormat.indexOf('/') > 0){ 
        $scope.delimeter = 'slash';
        $scope.olddelimeter = 'slash';
    }
    if($scope.settings.DateFormat.indexOf('.') > 0){ 
        $scope.delimeter = 'dot';
        $scope.olddelimeter = 'dot';
    }
    if($scope.settings.TimeFormat != ''){ $scope.showtime = true; }
    if($scope.settings.TimeFormat.indexOf("Z", $scope.settings.TimeFormat.length - 1) !== -1){ $scope.showtimezone = true; }
    // Controller Functions
    $scope.setTimeDisplay = function(){
        $scope.settings.TimeFormat = '';
        if($scope.showtime){$scope.settings.TimeFormat=" 'at' h:mma";}
        if($scope.showtimezone){$scope.settings.TimeFormat+="Z";}
        $scope.storeSettings();
    };
    $scope.changeFormats = function(){
        for (i in $scope.dtfFormats[$scope.olddelimeter]){
            if($scope.dtfFormats[$scope.olddelimeter][i] === $scope.settings.DateFormat){ 
                $scope.settings.DateFormat = $scope.dtfFormats[$scope.delimeter][i];
            }
        }
        $scope.olddelimeter = $scope.delimeter;
        i = $scope.dtfFormats[$scope.delimeter].indexOf($scope.settings.DateFormat); 
        $scope.settings.ChartDateFormat = $scope.graphdtfFormats[$scope.delimeter][i];
        $scope.storeSettings();
    };
    // For the DatePicker popup:
    $scope.open = function($event) {
      $event.preventDefault();
      $event.stopPropagation();

      $scope.opened = true;
    };
    $scope.storeDateRange = function(){
        $scope.parameters['enddate'] = new Date();
        $scope.parameters['startdate'] = new Date($scope.parameters.enddate.getTime() - $scope.settings.DateRange);
        $scope.storeSettings();
    };
    $scope.storeSettings = function(){
        $.cookie.json = true;
        $.cookie('Settings',$scope.settings,{ expires: 365 });
    };
});