/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// lssTestDataController
//
// This is to be used to verify the LSS-100P Post Web service. By invoking
// it from the application, Xdebug supports breakpoints and examination of
// variables. Total debug support!!!
//---------------------------------------------------------------------------
app.controller('lssTestDataController', function ($scope,$rootScope, lssTestDataService, dbDeleteService) {
    var recordNum = 900000;
    
    $scope.sendLssTestData = function (sampleType) {
        var tDay = new Date();
        var dateEpoch = parseInt(tDay.getTime()/1000);
        // Subtract seven days
        dateEpoch -= 604800;
        
        var lssData = null;
        // Remove simulated data from the database
        dbDeleteService.dbDelete(EnumDbDeleteCmds.DELETE_SIMULATIONS,null);
        
        // Create an LSS Test Result 
        switch(sampleType)
        {
            case 0:
                var splOutOfLimits = 0;
                var yOutOfLimits = 0;
                var xOutOfLimits = 0;
                var flOutOfLimits = 0;
                var valueDb=81.2;
                var valueX = 0.280;
                var valueY = 0.290;
                var valueLuminance = 13.5;
                lssData = '<?xml version="1.0" encoding="UTF-8"?><LssLogPost>'
                for(var i=0; i < 7; i++)
                {
                    // Add a day
                    dateEpoch += 86400;                                                  
                    splOutOfLimits = 0;
                    yOutOfLimits = 0;
                    xOutOfLimits = 0;
                    flOutOfLimits = 0;

                    recordNum++;
                    valueDb -= 0.25; 
                    valueX += valueX * 0.01;
                    valueY += valueY * 0.015;                    
                    
                    if(i>4)
                        valueLuminance += 0.5;                    
                                        
                    if(valueDb < 80.1 || valueDb > 85.1)
                        splOutOfLimits = 1;
                    // Simulated SPL
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>SPL Left Channel</Description>'+
                               '<Value>'+valueDb+'</Value>'+
                               '<Units>dB</Units>'+
                               '<Minimum>80.1</Minimum>'+
                               '<Maximum>85.2</Maximum>'+
                               '<OutsideLimits>'+splOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>1</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';
                    // Simulated Chromaticity Y
                    recordNum++;
                    if(valueY < 0.314 || valueY > 0.351)
                        yOutOfLimits = 1;
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>Color Y</Description>'+
                               '<Value>'+valueY+'</Value>'+
                               '<Units>y</Units>'+
                               '<Minimum>0.314</Minimum>'+
                               '<Maximum>0.351</Maximum>'+
                               '<OutsideLimits>'+yOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>1</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';                   
                    // Simulated Chromaticity X
                    recordNum++;
                    if(valueX < 0.314 || valueX > 0.351)
                        xOutOfLimits = 1;
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>Color X</Description>'+
                               '<Value>'+valueX+'</Value>'+
                               '<Units>y</Units>'+
                               '<Minimum>0.314</Minimum>'+
                               '<Maximum>0.351</Maximum>'+
                               '<OutsideLimits>'+xOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>1</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';
                    // Simulated Luminance ft-L
                    recordNum++;
                    if(valueLuminance < 14.1 || valueLuminance > 17.9)
                       flOutOfLimits = 1; 
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>Luminance</Description>'+
                               '<Value>'+valueLuminance+'</Value>'+
                               '<Units>ft-L</Units>'+
                               '<Minimum>14.1</Minimum>'+
                               '<Maximum>17.9</Maximum>'+
                               '<OutsideLimits>'+flOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>1</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';
                }
                lssData += '</LssLogPost>';
                break;
             case 1:
                var splOutOfLimits = 0;
                var yOutOfLimits = 0;
                var xOutOfLimits = 0;
                var flOutOfLimits = 0;
                
                recordNum++;
                var valueDb=70.3
                var valueX = 0.336;
                var valueY = 0.333;
                var valueLuminance = 12.5;
                
                lssData = '<?xml version="1.0" encoding="UTF-8"?><LssLogPost>'
                for(var i=0; i < 7; i++)
                {
                    // Add a day
                    dateEpoch += 86400;                                                  
                    splOutOfLimits = 0;
                    yOutOfLimits = 0;
                    xOutOfLimits = 0;
                    flOutOfLimits = 0;                   
                    valueDb -= i; 
                    valueX -= valueX * 0.012;
                    valueY -= valueY * 0.014;
                    valueLuminance -= 0.5;
                    
                    // Simulated SPL
                    if(valueDb < 80.1 || valueDb > 85.1)
                        splOutOfLimits = 1;
                     recordNum++;
                    lssData += '<Record>'+
                               '<RecordNum>'+recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>SPL Center Channel</Description>'+
                               '<Value>'+valueDb+'</Value>'+
                               '<Units>dB</Units>'+
                               '<Minimum>80.8</Minimum>'+
                               '<Maximum>85.2</Maximum>'+
                               '<OutsideLimits>'+splOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>2709</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>2</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';
                    // Simulated Chromaticity Y
                    recordNum++;
                    if(valueY < 0.314 || valueY > 0.351)
                        yOutOfLimits = 1;                    
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>Color Y</Description>'+
                               '<Value>'+valueY+'</Value>'+
                               '<Units>y</Units>'+
                               '<Minimum>0.314</Minimum>'+
                               '<Maximum>0.351</Maximum>'+
                               '<OutsideLimits>'+yOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>2</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';                   
                    // Simulated Chromaticity X
                    recordNum++;
                    if(valueX < 0.314 || valueX > 0.351)
                        xOutOfLimits = 1;
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>Color X</Description>'+
                               '<Value>'+valueX+'</Value>'+
                               '<Units>x</Units>'+
                               '<Minimum>0.314</Minimum>'+
                               '<Maximum>0.351</Maximum>'+
                               '<OutsideLimits>'+xOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>2</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';
                    // Simulated Luminance ft-L
                    recordNum++;
                    if(valueLuminance < 14.1 || valueLuminance > 17.9)
                       flOutOfLimits = 1; 
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>Luminance</Description>'+
                               '<Value>'+valueLuminance+'</Value>'+
                               '<Units>ft-L</Units>'+
                               '<Minimum>14.1</Minimum>'+
                               '<Maximum>17.9</Maximum>'+
                               '<OutsideLimits>'+flOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>2</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';   
                }
                lssData += '</LssLogPost>';
                break;
             case 2:
                var valueDb=81.3
                var valueX = 0.328;
                var valueY = 0.344;
                var valueLuminance = 16.2;
                lssData = '<?xml version="1.0" encoding="UTF-8"?><LssLogPost>'
                for(var i=0; i < 7; i++)
                {
                    // Add a day
                    dateEpoch += 86400;                                                  
                    splOutOfLimits = 0;
                    yOutOfLimits = 0;
                    xOutOfLimits = 0;
                    flOutOfLimits = 0;                   
                    recordNum++;
                    valueDb += 0.25; 
                    valueX += valueX * 0.001;
                    valueY -= valueY * 0.0015;
                    valueLuminance += 0.15;
                    if(valueDb < 80.1 || valueDb > 85.1)
                        splOutOfLimits = 1;
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>SPL Right Channel</Description>'+
                               '<Value>'+valueDb+'</Value>'+
                               '<Units>dB</Units>'+
                               '<Minimum>80.1</Minimum>'+
                               '<Maximum>85.1</Maximum>'+
                               '<OutsideLimits>'+splOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>2709</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>3</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';
                    // Simulated Chromaticity Y
                    recordNum++;
                    if(valueY < 0.314 || valueY > 0.351)
                        yOutOfLimits = 1;                    
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>Color Y</Description>'+
                               '<Value>'+valueY+'</Value>'+
                               '<Units>y</Units>'+
                               '<Minimum>0.314</Minimum>'+
                               '<Maximum>0.351</Maximum>'+
                               '<OutsideLimits>'+yOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>3</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';                   
                    // Simulated Chromaticity X
                    recordNum++;
                    if(valueX < 0.314 || valueX > 0.351)
                        xOutOfLimits = 1;
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>Color X</Description>'+
                               '<Value>'+valueX+'</Value>'+
                               '<Units>x</Units>'+
                               '<Minimum>0.314</Minimum>'+
                               '<Maximum>0.351</Maximum>'+
                               '<OutsideLimits>'+xOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>3</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';
                    // Simulated Luminance ft-L
                    recordNum++;
                    if(valueLuminance < 14.1 || valueLuminance > 17.9)
                       flOutOfLimits = 1; 
                    lssData += '<Record>'+
                               '<RecordNum>'+ recordNum.toString()+'</RecordNum>'+
                               '<DateTime>'+dateEpoch+'</DateTime>'+
                               '<Description>Luminance</Description>'+
                               '<Value>'+valueLuminance+'</Value>'+
                               '<Units>ft-L</Units>'+
                               '<Minimum>14.1</Minimum>'+
                               '<Maximum>17.9</Maximum>'+
                               '<OutsideLimits>'+flOutOfLimits+'</OutsideLimits>'+
                               '<SerialNumber>100007</SerialNumber>'+
                               '<OrgKey>'+$rootScope.Company+'</OrgKey>'+
                               '<TheaterName>San Luis Obispo</TheaterName>'+
                               '<TheaterNumber>-1</TheaterNumber>'+
                               '<AuditoriumNumber>3</AuditoriumNumber>'+                          
                               '<Comments>Simulation</Comments>'+
                               '<Firmware>150309</Firmware>'+
                               '<Hardware>C</Hardware>'+
                               '<IpAddress>192.168.6.110</IpAddress>'+
                               '</Record>';                       
                }
                lssData += '</LssLogPost>';
                break;
        }
        recordNum++;
        // Send the email item.
        if(lssData !== null)
            lssTestDataService.send(lssData);
    };
    
});

