/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// Group Management Controller
// 
// Provides functions for showing, editting and deleting groups.
// Database side protection will prevent unauthorized data from being shown.
//---------------------------------------------------------------------------
app.controller('modifyGroupsController', function ($scope, $rootScope, Data,
        allDataListSharedFactory, getParametersFactory, configurationFactory,  
        dbRequestService, dbAddService, dbDeleteService, dbUpdateService) {
            
    //-----------------------------------------------------------------------
    //                           Data        
    // Initialize our bindings
    //-----------------------------------------------------------------------
    $scope.level=$rootScope.Level;
    $scope.Company=$rootScope.Company;
    $scope.settings = configurationFactory;
    $scope.getParameters = getParametersFactory;
    $scope.RawData = [];
    $scope.Groups = [];
    $scope.UserGroups = [];
    $scope.TheaterGroups = [];
    $scope.Users = [];
    $scope.Theaters = [];
    $scope.selectedGroup = "";
    $scope.loadedGroup = {};
    $scope.loadedTheater = {};
    $scope.loadedUser = {};
    $scope.theaterToAdd = -1;
    $scope.userSelectList=[];
    $scope.theaterSelectList=[];
    
    // Get the Data for building the view
    $scope.GetData = function(){
        dbRequestService.dbRequest($scope.Groups, EnumDbCmds.GROUPS, "", "");
        dbRequestService.dbRequest($scope.UserGroups, EnumDbCmds.USERGROUPS, "", "");
        dbRequestService.dbRequest($scope.TheaterGroups, EnumDbCmds.THEATERGROUPS, "", "");
        dbRequestService.dbRequest($scope.Users, EnumDbCmds.USERS,"","");
        dbRequestService.dbRequest($scope.Theaters, EnumDbCmds.COLLECT_THEATER_GROUPS, "", "");
    };
    // Create an array for the dropdown with sorted OrgKey view
    // to improve readability.
    $scope.$watchCollection('Users', function(newNames, oldNames){
        if(newNames.length < 1)
            return;
                
        // Check for no orginization
        var orgKey = newNames[0].Company.length==0 ? '**No Organization':newNames[0].Company;       
        $scope.userSelectList.length=0;
        $scope.userSelectList.push({            
            UID:'0',
            Name:orgKey,
            Disable:true,
            Bold:true,
            Company:orgKey
        });

        angular.forEach(newNames, function(item){
            if(item.Company !== $scope.userSelectList[$scope.userSelectList.length-1].Company && $scope.userSelectList.length>1){
                orgKey = item.Company.length == 0 ? '**No Organization':item.Company;
                $scope.userSelectList.push({
                    UID:'0',
                    Name:orgKey,
                    Disable:true,
                    Bold:true,
                    Company:orgKey
                });
            };
            $scope.userSelectList.push(item);
            $scope.userSelectList[$scope.userSelectList.length-1]['Disable']=false;
            $scope.userSelectList[$scope.userSelectList.length-1]['Bold']=false;
        });
    });
    // Generate a list for creating a drop down list
    // with better formatting for readability
    $scope.$watchCollection('Theaters', function(newNames, oldNames){
        if(newNames.length < 1)
            return;
        
        $scope.theaterSelectList.length=0;
        $scope.theaterSelectList.push({
            TheaterNumber:'',
            TheaterName:newNames[0].OrgKey,
            Disable:true,
            Bold:true,
            OrgKey:newNames[0].OrgKey
        });
        angular.forEach(newNames, function(item){
            if(item.OrgKey !== $scope.theaterSelectList[$scope.theaterSelectList.length-1].OrgKey){
                $scope.theaterSelectList.push({
                    TheaterNumber:'',
                    TheaterName:item.OrgKey,
                    Disable:true,
                    Bold:true,
                    OrgKey:item.OrgKey
                });
            };
            $scope.theaterSelectList.push(item);
            $scope.theaterSelectList[$scope.theaterSelectList.length-1]['Disable']=false;
            $scope.theaterSelectList[$scope.theaterSelectList.length-1]['Bold']=false;
        });
    });
    $scope.loadGroupClick = function(g){
        $scope.selectedGroup = g.GID;
        $scope.loadedGroup = $.grep($scope.Groups, function(e){ return e.GID === $scope.selectedGroup; })[0];
        $scope.loadedTheater = {};
        $scope.loadedUser = {};
    };
    $scope.loadTheaterClick = function(t){
        $scope.selectedGroup = "";
        $scope.loadedGroup = {};
        $scope.loadedTheater = t;
        $scope.loadedUser = {};
    };
    $scope.loadUserClick = function(u){
        $scope.selectedGroup = "";
        $scope.loadedGroup = {};
        $scope.loadedTheater = {};
        $scope.loadedUser = u;
    };
    $scope.loadGroup = function(){
        $scope.loadedGroup = $.grep($scope.Groups, function(e){ return e.GID === $scope.selectedGroup; })[0];
    };
    $scope.NewGroup = function(e){ 
        $("#AddGroupDiv").css({left:e.pageX-50,top:e.pageY-50});
        $("#AddGroupDiv").show(200);
    };
    $scope.AddGroupSubmit = function(){
        if($scope.level!==2)
        { 
            $scope.OKToAdd = $scope.Company; 
        }
        var dataItem = new GroupsStruct(
                        '""',
                        '0',
                        $scope.GroupName,
                        $scope.OKToAdd);
        dbAddService.dbAdd(EnumDbAddCmds.GROUPS, dataItem);
        $("#AddGroupDiv").hide(200);
        setTimeout(function(){dbRequestService.dbRequest($scope.Groups, EnumDbCmds.GROUPS, "", "");},250);
    };
    $scope.DelGroup = function(g){
        if(confirm("This will delete the group "+g.GroupName+"!  Are you Sure?")){
            if($scope.loadedGroup.GID === g.GID){$scope.selectedGroup = "";}
            var dataItem = new GroupsStruct(
                            g.GID,
                            g.PID,
                            g.GroupName,
                            g.OrgKey);
            dbDeleteService.dbDelete(EnumDbDeleteCmds.GROUP, dataItem);
            setTimeout(function(){dbRequestService.dbRequest($scope.Groups, EnumDbCmds.GROUPS, "", "");},250);
        }
    };
    $scope.ModGroup = function(){
    };
    $scope.AddUser = function(e){
        $("#AddUserDiv").css({left:e.pageX-250,top:e.pageY-25});
        $("#AddUserDiv").show(200);
    };
    $scope.AddMe = function(){
        $scope.userToAdd = $scope.loadedUser.UID;
        $scope.AddUserSubmit($scope.subgroupToAdd);
    };
    $scope.AddUserSubmit = function(g){
        $("#AddUserDiv").hide(200);
        res = $.grep($scope.UserGroups, function(e){ return e.UserId === $scope.userToAdd && e.GroupId === g.GID; })
        if(res.length > 0){
            Data.toast({status:'error',message:"User already in group!"});
        }
        else{
            var dataItem = new UserGroupsStruct();
            dataItem.UGID = " ";                         // Non Blank filler
            dataItem.UserId = $scope.userToAdd;          // UserID
            dataItem.GroupId = g.GID;   // Selected Group ID
            dataItem.Active = 1;                         // Not used but make active for now
            dbAddService.dbAdd(EnumDbAddCmds.USERGROUPS, dataItem);
            $scope.userToAdd = "";
            setTimeout(function(){dbRequestService.dbRequest($scope.UserGroups, EnumDbCmds.USERGROUPS, "", "");},250);
        }
    };
    $scope.DelUserGroup = function(ug){
        res = $.grep($scope.UserGroups, function(e){ return e.UGID === ug.UGID; });
        if(res.length === 0){
            Data.toast({status:'error',message:"User not in group!"});
        }
        else{
            var dataItem = new UserGroupsStruct();
            dataItem.UGID = " ";              // Non Blank filler   
            dataItem.UserId = ug.UserId;
            dataItem.GroupId = ug.GroupId;
            dataItem.Active = " ";      // Non Blank filler
            dbDeleteService.dbDelete(EnumDbDeleteCmds.USERGROUP, dataItem);
            setTimeout(function(){dbRequestService.dbRequest($scope.UserGroups, EnumDbCmds.USERGROUPS, "", "");},250);
        }
    };
    $scope.AddTheater = function(e){
        $("#AddTheaterDiv").css({left:e.pageX-350,top:e.pageY-25});
        $("#AddTheaterDiv").show(200);
    };
    $scope.AddTh = function(){
        res = $.grep($scope.TheaterGroups, function(e){ return (e.OrgKey === $scope.loadedTheater.OrgKey && (e.TheaterNumber === $scope.loadedTheater.TheaterNumber && e.GroupId === g.GID)); });
        if(res.length > 0){
            Data.toast({status:'error',message:"Theater already in group!"});
        }
        else{
            var dataItem = new TheaterGroupsStruct();
            dataItem.TheaterNumber = $scope.loadedTheater.TheaterNumber;
            dataItem.OrgKey = $scope.loadedTheater.OrgKey;
            dataItem.GroupId = $scope.subgroupToAdd.GID;                 // Selected Group ID
            dbAddService.dbAdd(EnumDbAddCmds.THEATERGROUPS, dataItem);
            setTimeout(function(){dbRequestService.dbRequest($scope.TheaterGroups, EnumDbCmds.THEATERGROUPS, "", "");},250);
        }
    };
    $scope.AddTheaterSubmit = function(g){
        $("#AddTheaterDiv").hide(200);
        var selectedTh = $scope.theaterSelectList[$scope.theaterToAdd];
        res = $.grep($scope.TheaterGroups, function(e){ return (e.OrgKey === selectedTh.OrgKey && (e.TheaterNumber === selectedTh.TheaterNumber && e.GroupId === g.GID)); });
        if(res.length > 0){
            Data.toast({status:'error',message:"Theater already in group!"});
        }
        else{
            var dataItem = new TheaterGroupsStruct();
            dataItem.TheaterNumber = selectedTh.TheaterNumber;
            dataItem.OrgKey = selectedTh.OrgKey;
            dataItem.GroupId = g.GID;                 // Selected Group ID
            dbAddService.dbAdd(EnumDbAddCmds.THEATERGROUPS, dataItem);
            setTimeout(function(){dbRequestService.dbRequest($scope.TheaterGroups, EnumDbCmds.THEATERGROUPS, "", "");},250);
        }
    };
    $scope.DelTheater = function(theater){
        res = $.grep($scope.TheaterGroups, function(e){ return e === theater; })
        if(res.length === 0){
            Data.toast({status:'error',message:"User not in group!"});
        }
        else{
            var dataItem = new TheaterGroupsStruct();
            dataItem.TGID = " ";        // Non Blank filler
            dataItem.TheaterNumber = theater.TheaterNumber;
            dataItem.OrgKey = theater.OrgKey;
            dataItem.GroupId = theater.GroupId;      // Non Blank filler
            dbDeleteService.dbDelete(EnumDbDeleteCmds.THEATERGROUP, dataItem);
            setTimeout(function(){dbRequestService.dbRequest($scope.TheaterGroups, EnumDbCmds.THEATERGROUPS, "", "");},250);
        }
    };
    
    $scope.AddSubgroup = function(e){
        $("#AddSubgroupDiv").css({left:e.pageX-200,top:e.pageY-100});
        $("#AddSubgroupDiv").show(200);
    };
    $scope.AddSubgroupSubmit = function(){
        if($scope.subgroupToAdd.PID !== "0"){
            if(!confirm("Warning: This will overwrite "+$scope.subgroupToAdd.GroupName+"'s previous association.")){
                return;
            }
        }
        // Check for loops
        var mygroup = $scope.loadedGroup.GID;
        var foundgroups = [];
        do{
            var res = $.grep($scope.Groups, function(e){ return e.GID === mygroup; });
            if(res.length === 0 ){
                mygroup = '0';
            }
            else{
                mygroup = res[0].PID;
            }
            if(mygroup === $scope.subgroupToAdd.GID){
                Data.toast({status:'error',message:"Cannot add a subgroup to a subgroup. (loop)"});
                return;
            }
        } while(mygroup !== '0');
        var dataItem = new GroupsStruct(
                $scope.subgroupToAdd.GID,
                $scope.loadedGroup.GID,  // Add current group as PID
                $scope.subgroupToAdd.GroupName,
                $scope.subgroupToAdd.OrgKey);
        dbUpdateService.dbUpdate(EnumDbUpdateCmds.GROUPS, dataItem);
        // Update the collection to show the change
        $("#AddSubgroupDiv").hide(200);
        setTimeout(function(){dbRequestService.dbRequest($scope.Groups, EnumDbCmds.GROUPS, "", "");},250);
    };
    $scope.DelSubgroup = function(group){
        var dataItem = new GroupsStruct(
                group.GID,
                "0",  // Remove Parent ID
                group.GroupName,
                group.OrgKey);
        dbUpdateService.dbUpdate(EnumDbUpdateCmds.GROUPS, dataItem);
        setTimeout(function(){dbRequestService.dbRequest($scope.Groups, EnumDbCmds.GROUPS, "", "");},250);
    };
    

    $scope.PGroupName = function(){
        g = $.grep($scope.Groups, function(e){ return e.GID === $scope.loadedGroup.PID; });
        if(g.length>0 ){ return "Subgroup of "+g[0].GroupName; }
        return "";
    };
    $scope.GetUser = function(id){
        g = $.grep($scope.Users, function(e){ return e.UID === id; });
        if(g.length>0 ){ return g[0]; }
        return null;
    }
    $scope.GetGroup = function(id){
        g = $.grep($scope.Groups, function(e){ return e.GID === id; });
        if(g.length>0 ){ return g[0]; }
        return null;
    }
    $scope.GetTheater = function(num,OK){
        g = $.grep($scope.Theaters, function(e){ return e.TheaterNumber === num && e.OrgKey === OK; });
        if(g.length>0 ){ return g[0]; }
        return null;
    }
    
    //-----------------------------------------------------------------------
    //                           Web Services 
    // Invoke services to get data.
    //-----------------------------------------------------------------------
    $scope.GetData();
    
});
