/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// newCompanyController
// 
// As part of the database administration this controller interfaces with
// the "add new company" view (page). The rule being for each company an 
// administrator account is created. That account will then be used to 
// setup and manage user resources. This is the starting spot for entering
// a new company to the database.
//---------------------------------------------------------------------------
app.controller('newCompanyController', function ($scope, $location, Data, dbAdminService) {

    //-----------------------------------------------------------------------
    //                       Companies Data Grid
    //-----------------------------------------------------------------------
    $scope.CompaniesStatus = [];
    // Configure the ui-grid
    $scope.companiesStatusGridOptions = {
        enableRowSelection: false,
        enableSelectAll: false,
        multiSelect: false,
        minRowsToShow:10,
        enableColumnMenus: false,
        enableHorizontalScrollbar:0,
        enableVerticalScrollbar:1,
        pagingPageSizes:1,
        pagingPageSize: 1,
        
        columnDefs: [{field:'Company', displayName:'Company / Organization', width: '100%', cellClass:'grid-align-left'}]
    };

    $scope.companiesStatusGridOptions.data = $scope.CompaniesStatus;

    //-----------------------------------------------------------------------
    //                              Data 
    //-----------------------------------------------------------------------
    $scope.signup = {};

    // Dropdown list source.
    $scope.notifyLevels = [
        {
            text: 'None',
            value: EnumNotifyLevels.NONE
        }, {
            text: 'Errors Only',
            value: EnumNotifyLevels.ERRORSONLY
        }, {
            text: 'All',
            value: EnumNotifyLevels.ALL
        }
    ];
    // Initialize with the default selection.
    $scope.signup.NotificationType = EnumNotifyLevels.NONE;

    //-----------------------------------------------------------------------
    // addAdministrator
    //
    // This will add an administrator to the database. 
    //-----------------------------------------------------------------------
    $scope.addAdministrator = function (customer) {
        Data.post('managerSignUp', {
            customer: customer
        }).then(function (results) {
            Data.toast(results);  
            if (results.status === "success") {
                $scope.CompaniesStatus = [];
                $scope.companiesStatusGridOptions.data = $scope.CompaniesStatus;
                dbAdminService.dbAdmin($scope.CompaniesStatus, EnumDBAdminCmds.COMPANIES,"","");
            }
        });
    };

    //-----------------------------------------------------------------------
    //                           Web Service
    //-----------------------------------------------------------------------
    dbAdminService.dbAdmin($scope.CompaniesStatus, EnumDBAdminCmds.COMPANIES,"","");
});