/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA - www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// notificationAdminController
//
// This will interface with the Notification Administration page to configure 
// the notification admin settings.
//---------------------------------------------------------------------------
app.controller('notificationAdminController', function ($scope, notificationService) {
    $scope.notificationsSettingsDisable = true;
    $scope.Settings = new NotificationAdminStruct();
    
    //-----------------------------------------------------------------------
    //                   Web Service Request
    //-----------------------------------------------------------------------
    notificationService.getSettings($scope.Settings);

    //-----------------------------------------------------------------------
    // $watch Settings
    //
    // When a server response is received this will enable the settings
    // buttons. 
    //-----------------------------------------------------------------------
    $scope.$watch('Settings', function(newValue){
        if(newValue instanceof NotificationAdminStruct)
        {
            if(newValue.Valid === true)
            {
                $scope.notificationsSettingsDisable = false;
            }
        }
    },true);    

    $scope.testCronNotifications = function(){
        notificationService.testCron($scope.Settings);
    };

    $scope.getNotificationSettings = function () {
        notificationService.getSettings($scope.Settings);
    };

    $scope.setNotificationSettings = function () {
        notificationService.setSettings($scope.Settings);
    };

});
