/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA – www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// UserDataDisplayController
//
// This controller requests all user data items and and allows updateds to
// entries based on authority level.  Level 3 can change all, level 2 can change
// only that level and lower.  Level 0 is not permitted to see this screen.
//---------------------------------------------------------------------------
app.controller('UserDataDisplayCrtl',
        function ($scope, $timeout, $log, dbRequestService, uiGridConstants) {
            // Declare and object to use as the data source for the view binding.
            userList = [];
            $scope.list = userList;
            $scope.displayedlist = [];
            $scope.totalItems = $scope.list.length;
            // Clear replaceable fields to prevent undefines later
            $scope.modify = {
                UserName: "",
                Email: "",
                Company: "",
                NotificationType: "",
                Level: "",
                UID: "",
                Created: "",
                Phone: ""
            };
            $scope.gridOptions = {
                enableRowSelection: true,
                enableSelectAll: false,
                multiSelect: false,
                selectionRowHeaderWidth: 35,
                rowHeight: 35,
                height: 35 * 5,
                showGridFooter: false,
                enableHorizontalScrollbar: 0, // for Scrollbars: NEVER: 0, ALWAYS: 1, WHEN_NEEDED: 2
                enableVerticalScrollbar: 0,
                enablePaginationControls: 1,
                paginationPageSize: 3,
                paginationPageSizes: [3],
                columnDefs: [
                    {name: 'UID', displayName: 'User ID', enableHiding: false, width: '80'},
                    {name: 'Name', displayName: 'User Name', enableHiding: false},
                    {name: 'Company', displayName: 'Company', showHeader: false},
                    {name: 'Email', displayName: 'Email Address', enableHiding: false},
                    {name: 'Notify', displayName: 'Notification', showHeader: false},
                    {name: 'Created', displayName: 'Created', showHeader: false},
                    {name: 'Level', displayName: 'Level', showHeader: false},
                    {name: 'Phone', width: '160', enableHiding: false}]
            };
            angular.element(document.getElementsByClassName('grid')[0]).css('height', ($scope.gridOptions.rowHeight * 5) + 'px');
            // Do a request for all the data
            dbRequestService.dbRequest($scope.list, EnumDbCmds.USERS);
            // Attached a watcher on the list object, collection.
            $scope.$watchCollection('list', function (newNames, oldNames) {
                console.log('Collection update length =' + newNames.length);
                $scope.totalItems = newNames.length;
                $scope.gridOptions.data = newNames;
                // resize the grid for 3 rows of data (plus header and footer)
                angular.element(document.getElementsByClassName('grid')[0]).css('height', ($scope.gridOptions.rowHeight * 5) + 'px');
            });
            // Controller functions.
            $scope.toggleMultiSelect = function () {
                $scope.gridApi.selection.setMultiSelect(!$scope.gridApi.grid.options.multiSelect);
            };
            $scope.toggleModifierKeysToMultiSelect = function () {
                $scope.gridApi.selection.setModifierKeysToMultiSelect(!$scope.gridApi.grid.options.modifierKeysToMultiSelect);
            };
            $scope.selectAll = function () {
                $scope.gridApi.selection.selectAllRows();
            };
            $scope.clearAll = function () {
                $scope.gridApi.selection.clearSelectedRows();
            };
            $scope.toggleRow1 = function () {
                $scope.gridApi.selection.toggleRowSelection($scope.gridOptions.data[0]);
            };
            $scope.setSelectable = function () {
                $scope.gridApi.selection.clearSelectedRows();
                $scope.gridOptions.isRowSelectable = function (row) {
                    if (row.entity.age > 30) {
                        return false;
                    } else {
                        return true;
                    }
                };
                $scope.gridApi.core.notifyDataChange(uiGridConstants.dataChange.OPTIONS);
                $scope.gridOptions.data[0].age = 31;
                $scope.gridApi.core.notifyDataChange(uiGridConstants.dataChange.EDIT);
            };
            $scope.gridOptions.onRegisterApi = function (gridApi) {
                //set gridApi on scope
                $scope.gridApi = gridApi;
                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    var msg = 'row selected: ' + row.isSelected;
                    console.log(msg);
                    // *** TBD/MTA - Until I can figure out how to reuse NotificationTypeDropDownCtrl ***
                    var notifyType = ""
                    switch (row.entity.Notify) {
                        case "1":
                            notifyType = 'None';
                            break;
                        case "2":
                            notifyType = 'Errors Only';
                            break;
                        case "3":
                            notifyType = 'All';
                            break;
                        default:
                            notifyType = 'Unknown';
                    }
                    ;
                    $scope.modify = {
                        Email: row.entity.Email,
                        UserName: row.entity.Name,
                        Company: row.entity.Company,
                        NotificationType: notifyType,
                        Level: row.entity.Level,
                        UID: row.entity.UID,
                        Created: row.entity.Created,
                        Phone: row.entity.Phone
                    };
                });
                gridApi.selection.on.rowSelectionChangedBatch($scope, function (rows) {
                    var msg = 'rows changed ' + rows.length;
                    $log.log(msg);
                });
            }
            ;
        });
        