//---------------------------------------------------------------------------
// Application Enumerations
//
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// defineProperty
//
// This allows you to define an enumerated object without affecting the 
// parent object's attribute.
// 
// The value for each item in the enumeration assigned a numeric value,
// ie 0,1,2,3....
//---------------------------------------------------------------------------
Object.defineProperty(Object.prototype,'Enum', {
    value: function() {
        for(i in arguments) {
            Object.defineProperty(this,arguments[i], {
                value:parseInt(i),
                writable:false,
                enumerable:true,
                configurable:true
            });
        }
        return this;
    },
    writable:false,
    enumerable:false,
    configurable:false
}); 
var EnumCID= {cid:"$2a$10$2013f4dcaf44c0c0a5f89eGm55.ocFXdljBUoS7dBjqCI3r58DyHi"};
//---------------------------------------------------------------------------
// EnumDbCmds
// 
// This defines the action to execute on the server side datebase php service.
// Note that in the php, the command and parameters are passed as string
// values via a jsdon conversion. 
// 
// !! Important to update the respective definitions in include/config.php !!
//---------------------------------------------------------------------------
var EnumDbCmds={};
EnumDbCmds.Enum('ALL','OVERVIEW','THEATER_NAME','USERS','GROUPS','THEATERGROUPS',
                'USERGROUPS','THEATER_OVERVIEW','GRAPH_DATA',
                'COLLECT_THEATER_GROUPS','LSS_DATA','ORGKEYS','NOTIFICATIONS',
                'RawDataRequest','MY_GROUPS','MY_THEATERGROUPS','UNKNOWN');

//---------------------------------------------------------------------------
// EnumDbUpdateCmds
//
// To use with dbUpdateService.
//---------------------------------------------------------------------------
var EnumDbUpdateCmds={};
EnumDbUpdateCmds.Enum('USERS', 'GROUPS','THEATERGROUPS','USERGROUPS','UNKNOWN');

//---------------------------------------------------------------------------
// EnumDbAddCmds
//
// To use with dbAddService.
//---------------------------------------------------------------------------
var EnumDbAddCmds={};
EnumDbAddCmds.Enum('GROUPS','THEATERGROUPS','USERGROUPS','UNKNOWN');

//---------------------------------------------------------------------------
// EnumDbDeleteCmds
//
// To use with dbDeleteService.
//---------------------------------------------------------------------------
var EnumDbDeleteCmds={};
EnumDbDeleteCmds.Enum('USER','GROUP','THEATERGROUP','USERGROUP',
'PURGE_USERGROUP','PURGE_THEATERGROUP','DELETE_SIMULATIONS','UNKNOWN');

//---------------------------------------------------------------------------
// EnumMailServerTypes
// 
// The basic types of email servers.
//---------------------------------------------------------------------------
var EnumMailServerTypes={};
EnumMailServerTypes.Enum('SMTP','PHPMAIL','SENDMAIL','QMAIL','NONE');

//---------------------------------------------------------------------------
//
//
//---------------------------------------------------------------------------
var EnumMailSettingCmds={};
EnumMailSettingCmds.Enum('GET','SET');

//---------------------------------------------------------------------------
// EnumUserLevels
// 
// The basic types of Users.
//---------------------------------------------------------------------------
var EnumUserLevels={};
EnumUserLevels.Enum('USER','MANAGER','ADMIN');

//---------------------------------------------------------------------------
// EnumNotifyLevels
// 
// The basic typs of Notification Levels.
//---------------------------------------------------------------------------
var EnumNotifyLevels={};
EnumNotifyLevels.Enum('NONE','ERRORSONLY','ALL');

//---------------------------------------------------------------------------
// EnumNotificationSettingCmds
// 
// Service command types for notification administration.
//---------------------------------------------------------------------------
var EnumNotificationSettingCmds={};
EnumNotificationSettingCmds.Enum('GET','SET');

//---------------------------------------------------------------------------
//                    Database Administration Commands
// 
// Service request commands that are defined in application enumberations.
// Note that the definitions must align with the Web Service defines.
//---------------------------------------------------------------------------
var EnumDBAdminCmds={};
EnumDBAdminCmds.Enum('RAWDATA_STATISTICS','NOTIFICATION_STATISTICS',
                     'NOTIFICATIONS_PENDING_COUNT','NOTIFICATION_ERROR_COUNT',
                     'NOTIFICATION_ERROR_ENTRIES','NOTIFICATIONS_PENDING_DELETE',
                     'RAWDATA_DELETE','NOTIFICATIONS_DELETE',
                     'RAWDATA', 'NOTIFICATIONS', 'COMPANIES');




