/*******************************************************************************
* 
*    ULTRA STEREO LABS CONFIDENTIAL
*    _____________________________________________________________________
* 
*       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
*                         All Rights Reserved.
* 
*    NOTICE:  All information contained herein is, and remains
*    the property of Ultra Stereo Labs Incorporated and its suppliers,
*    if any.  The intellectual and technical concepts contained
*    herein are proprietary to Ultra Stereo Labs Incorporated
*    and its suppliers and may be covered by U.S. and Foreign Patents,
*    in process, and are protected by trade secret or copyright law.
*    Dissemination of this information or reproduction of this material
*    is strictly forbidden unless prior written permission is obtained
*    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, San Luis Obispo, 
*    California 93401-7397, USA - www.uslinc.com
*
*    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
*    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
*    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
*    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*
*
*******************************************************************************/
//---------------------------------------------------------------------------
// dataStructs
//
// Common object types used for storing respective data group items.
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//                        LSS Data Structure
//---------------------------------------------------------------------------
function OverviewStruct(name, tn, an, ok) {
                    this.TheaterName = name;
                    this.TheaterNumber = tn;
                    this.AuditoriumNumber = an;
                    this.OrgKey = ok;
                }

function AllStruct(name, tn, an, dscr, val, unit, min, max, ser){
                    this.TheaterName = name;
                    this.TheaterNumber = tn;
                    this.AuditoriumNumber = an;
                    this.Description = dscr;
                    this.Value = val;
                    this.Units = unit;
                    this.Minimum = min;
                    this.Maximum = max;
                    this.SerialNumber = ser;
                }
function TheaterOverviewStruct( name, tn, an, oot, desc, val, datetime, min, max, units, orgkey) {
                    this.TheaterName = name;
                    this.TheaterNumber = tn;
                    this.AuditoriumNumber = an;
                    this.Description = desc;
                    this.Value = val;
                    this.OutsideLimits = oot;
                    this.DateTime = datetime;
                    this.Minimum = min;
                    this.Maximum = max,
                    this.Units = units;
                    this.OrgKey = orgkey;
                }
function LSSDataStruct( hw, fw, ipadd, sn, comment){
                    this.Hardware = hw;
                    this.Firmware = fw;
                    this.IPAddress = ipadd;
                    this.SerialNumber = sn;
                    this.Comments = comment;
                }
function NotificationDataStruct( sdt, rdt, rdid ){
                    this.SentDateTime = parseFloat(sdt)*1000;
                    this.ReceivedDateTime = parseFloat(rdt)*1000;
                    this.RawDataId = parseFloat(rdid);
                    mydate = new Date(parseFloat(sdt)*1000);
                    this.SentDate = this.SentDateTime > 1000 ? mydate.toLocaleDateString(): sdt; 
                }
//---------------------------------------------------------------------------
//  For Graphing data 
//---------------------------------------------------------------------------
function GraphDataStruct( datetime, value, units){;
                    this.x = parseFloat(datetime);
                    this.y = parseFloat(value);
                    this.units = units;
}
//---------------------------------------------------------------------------
//                        Users Data Structure
//                        
//  This is the data type associated with 'users' table                     
//---------------------------------------------------------------------------
function UsersStruct(uid, name, company, notify, level, email, phone, created) {
    this.UID = uid;
    this.Name = name;
    this.Company = company;
    this.Notify = notify;
    this.Level = level;
    this.Email = email;
    this.Phone = phone;
    this.Created = created;
}

//---------------------------------------------------------------------------
//                            User Data Structure
// 
// Properties shown in the view and passed to the Web service. Note defaults
// and property names to match database column names.
//---------------------------------------------------------------------------
function UserStruct(){
    this.UserName = "";
    this.Company = "";
    this.Password = "";
    this.Level = EnumUserLevels.USER;    
    this.NotificationType = EnumNotifyLevels.NONE;
    this.Email = "";
    this.Phone = "";
}

//---------------------------------------------------------------------------
//                        Groups Data Structure
//---------------------------------------------------------------------------
function GroupsStruct(gid, pid, groupname, orgkey) {
    this.GID = gid;
    this.PID = pid;
    this.GroupName = groupname;
    this.OrgKey = orgkey;
}

//---------------------------------------------------------------------------
//                    Theater Groups Data Structure
//---------------------------------------------------------------------------
function TheaterGroupsStruct(tgid, theaterno, orgkey, groupid) {
    this.TGID = tgid;
    this.TheaterNumber = theaterno;
    this.OrgKey = orgkey;
    this.GroupId = groupid;
}

//---------------------------------------------------------------------------
//                     User Groups Data Structure
//---------------------------------------------------------------------------
function UserGroupsStruct(ugid, userid, groupid, active) {
    this.UGID = ugid;
    this.UserId = userid;
    this.GroupId = groupid;
    this.Active = active;
}

//---------------------------------------------------------------------------
//                     Theater Groups Collection Data Structure
//---------------------------------------------------------------------------
function TheaterGroupCollectionStruct(theaterno, orgkey, name) {
    this.TheaterNumber = theaterno;
    this.OrgKey = orgkey;
    this.TheaterName = name;
}

//---------------------------------------------------------------------------
//                     OrgKeys Collection Data Structure
//---------------------------------------------------------------------------
function OrgKeyCollectionStruct(value, orgkey) {
    this.value  = value;
    this.OrgKey = orgkey;
}

//---------------------------------------------------------------------------
//                         Email Message Data Structure
//  
//  The following are noted references in PhpMailer.                       
//                                                                       
//  From = 'root@localhost.com'
//  FromName = 'LSS Web Server'
//  To = 'root@localhost.com' as user name
//  addAddress('root@localhost.com', 'User Name') or To and ToName
// 
//  isHTML(true);
//  Subject = 'Subject'
//  Body    = 'Message body <b>HTML</b>'
//  AltBody = 'Plain text for non-HTML mail clients'                       
//---------------------------------------------------------------------------
function EmailMessageStruct(){
    this.From = 'root@localhost.com';
    this.FromName = 'LSS Web Server';
    this.To = 'root@localhost.com';
    this.ToName = 'User Name';
    this.isHTML = true;
    this.Subject = 'Subject, LSS Test Message';
    this.Body = 'Message body <b>HTML LSS Test Message</b>';
    this.AltBody = 'Plain text for non-HTML mail clients, LSS Test Message';
}

//---------------------------------------------------------------------------
//                          Email Settings Data Structure
//
//---------------------------------------------------------------------------
function EmailSettingsStruct() {
    this.ServerType = EnumMailServerTypes.PHPMAIL;
    this.SMTPAuth = false;
    this.SMTPSecure = 'tls';
    this.HostName = 'localhost.com';
    this.Port = 25;
    this.Username = 'root@localhost.com';
    this.Password = 'password';
    this.Valid = false;
}

//---------------------------------------------------------------------------
//                        Notifications Data Structurs
//
// A basic set of tables to track email reporting and administrative option
// for how they are sent.
//---------------------------------------------------------------------------
function NotificationAdminStruct() {
    this.id = 0;
    this.StatusText = "";
    this.Running = 0;
    this.LastCronRun = "None";
    this.Errors = 0;
    this.IntervaluSecs = 1000;
    this.DomainNameServer = "";
    this.FromAddress = "";
    this.FromName = "";
    this.LastSent = 0;
    this.Valid = false;
}

function NotificationsSentStruct() {
    this.id = 0;
    this.RawDataId = 0;
    this.ReceivedDataTime = "";
    this.Email = "";
    this.SentDataTime = "";
}

//---------------------------------------------------------------------------
//                   Database Administration Data Structures
//
//---------------------------------------------------------------------------
function TableStatusStruct(){
    this.count;
    this.newest;
    this.oldest;    
}

function NotificationDbAdminStruct(){
    this.id = 0;
    this.RawDataId = 0;
    this.ReceivedDateTime = "";
    this.Email = "";
    this.SentDateTime = "";
}

function RawDataDbAdminStruct(){
    this.id = 0;
    this.OrgKey = "";
    this.DateTime = "";
    this.TheaterNumber = 0;
}

//---------------------------------------------------------------------------
//                          Watch Object Type
//
// In order to detect a change the watch item must be an object, it will 
// inherit interface properties. See _proto_ 
//---------------------------------------------------------------------------
function ValueItemStruct(){
    this.Boolean = false;
    this.Integer = 0;
}

//---------------------------------------------------------------------------
// ListItemStruct
// 
// An object that contains properties that are bound to the control. A select
// requires a value and text properties to show the description with an 
// associated item number (value).
//---------------------------------------------------------------------------
function ListItemStruct(){
    this.value = 0;
    this.text = "";
}
//---------------------------------------------------------------------------
// Graph objecto Constructor (for multi-graphing)
//
//---------------------------------------------------------------------------
function GraphClass(name,dataarr,settingobj){
    this.data = dataarr.slice();
    this.settings = jQuery.extend({},settingobj);
    this.description = name;
};

//---------------------------------------------------------------------------
// Toaster data structure.
//
// The messages displayed in the popup along the left lower side use 
// a status and message properties to show a respective type of message 
// with icon.
// 
// The status string definitions are as follows:
// "error"
// "info"
// "success"
// "warning"
//---------------------------------------------------------------------------
function ToasterDataStruct(){
    this.status = "error";
    this.message="uknown";
}