<?php
    /************************************************************************
    * 
    *    ULTRA STEREO LABS CONFIDENTIAL
    *    ____________________________________________________________________
    * 
    *       Copyright (c) 2014 - 2015 Ultra Stereo Labs Incorporated 
    *                         All Rights Reserved.
    * 
    *    NOTICE:  All information contained herein is, and remains
    *    the property of Ultra Stereo Labs Incorporated and its suppliers,
    *    if any.  The intellectual and technical concepts contained
    *    herein are proprietary to Ultra Stereo Labs Incorporated
    *    and its suppliers and may be covered by U.S. and Foreign Patents,
    *    in process, and are protected by trade secret or copyright law.
    *    Dissemination of this information or reproduction of this material
    *    is strictly forbidden unless prior written permission is obtained
    *    from Ultra Stereo Labs Incorporated. 181 Bonetti Drive, 
    *    San Luis Obispo, California 93401-7397, USA – www.uslinc.com
    *
    *    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
    *    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    *    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
    *    IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
    *    CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
    *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
    *
    *
    ************************************************************************/
    //--------------------------------------------------------------------
    // authenticate.php
    // Check for a valid session and user before running a php script.
    // Only POST requests are support, send a 404 error if any other request
    // type comes in.
    // Check and start the current session.  If a user exists, continue.  In all
    // other cases send the "AUTHENTICATION" message and exxit.
    //-----------------------------------------------------------------------
    if($_SERVER['REQUEST_METHOD'] == "POST"){
        // Check the current session for the userid.  Force quit if not available.
        if (!isset($_SESSION)) {
            session_start();
        }
        if (!isset($_SESSION['UID'])) {// Kill the request if there is no userid in the current session
            $response = array();
            $response['status']  = "error";
            $response['message'] = "Authentication failed.";
            $json_commandResponse = json_encode($response);
            echo $json_commandResponse;    
            exit;
        }
    }
    else{
        http_response_code(404);
        exit;
    }
    
    //-----------------------------------------------------------------------
    // HasAccess
    //
    // This function will be used to determine if the logged in user 
    // has access prevelidges for the selected view and or controls within
    // a view (page). 
    // 
    // When $terminate is true this service call is termated with a toater
    // error message. 
    // 
    // When $terminate is false, only the true/false returned value is done.
    //-----------------------------------------------------------------------
    function HasAccess($level, $terminate)
    {        
        // Check the current session for current level.
        if (!isset($_SESSION)) {
            session_start();
        }
        // When user has access, just return otherwise
        // respond with a toaster message.
        if(intval($_SESSION['Level']) >= $level)
        {
            return true;
        }else if($terminate === true){
            $response = array();
            $response['status'] = "error";
            $response['message'] = "Access Denied, Insufficient user priviledges, see administrator";
            $json_response = json_encode($response);
            // # Return the response
            echo $json_response;
            exit();
        }else{
            return false;
        }
            
    }
    
    
?>