<?php
    //-----------------------------------------------------------------------
    // requestData
    // 
    // The client will post a database action type (command) to perform. 
    // The actions are defined in lib/appEnum and are used by the controller
    // and service to send it to this server side php service as a post.
    // 
    // In the service, then client side javascript, the command and parameters
    // are json encoded that is then coverted into a string and passed in
    // the post request. The command type and parameters are used for 
    // determining the database query action.
    //-----------------------------------------------------------------------
    // Check authentication of user and the request type, if not authenticated
    // the script will terminate execution with continuing to execute the 
    // following code.
    // 
    // When getting here the user and request has been authenticated
    // Get the Database configuration.
    include_once('../includes/config.php');
    if (!isset($_SESSION)) {
            session_start();
        }
    // Create an instance of a database interface API.
    $mysqli = new mysqli($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME);
    // Retrieve the jason data passed in the post.
    $str_json = file_get_contents('php://input');
    // Convert the jason data to an associative array.
    $dataArray = json_decode($str_json, true);
    
    $ThPairs = GetUsersTheaters($_SESSION['UID'],$mysqli);
    print_r($ThPairs);
    $ThStr = QueryFromPairs($ThPairs);
    $UserLevel = intval($_SESSION['Level']);
    print_r($ThStr);
    $query = $NONE;
    $result = null;

    // Process the service request type
    switch($dataArray['command'])
    {
        case $DB_CMD_ALL:
            $query="select distinct c.TheaterName, c.TheaterNumber, c.AuditoriumNumber, c.Description, "
                   ."c.Value, c.Units, c.Minimum, c.Maximum, c.SerialNumber from RawData c";
            $query.=" WHERE (".$ThStr.") order by c.SerialNumber";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_CMD_OVERVIEW:                
            $query="select distinct c.TheaterName, c.TheaterNumber, c.AuditoriumNumber from RawData c";
            $query.=" WHERE (".$ThStr.") order by c.TheaterNumber, c.AuditoriumNumber";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_CMD_THEATER:
            // $query="select distinct c.TheaterName, c.TheaterNumber, c.AuditoriumNumber from RawData c order by c.SerialNumber";
            $query="select * from RawData where (\"".$dataArray['param1']."\" in (TheaterName))";
            $query.=" AND (".$ThStr.")";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;           
        case $DB_USER_DATA_ALL:
            $query="select c.UID, c.UserName, c.Company, c.NotificationType, c.Level, "
                   ."c.Email, c.Phone, c.Created from users c WHERE ";
            if($UserLevel< USER_ADMIN){
                $query.="c.Company=\"".$_SESSION['Company']."\" AND ";
            }
            $query.="c.Level<=\"".$UserLevel."\"";
            $query.=" order by c.UserName";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_CMD_GROUPS:
            $query="select distinct c.GID, c.PID, c.GroupName, c.OrgKey from groups c ";
            if($UserLevel<USER_ADMIN){
                $query.="WHERE (c.OrgKey='".$_SESSION['Company']."') ";
            }
            $query.="order by c.GroupName";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);                
            break;
        case $DB_CMD_THEATERGROUPS:
            $query="select c.TGID, c.TheaterNumber, c.OrgKey, c.GroupID from theatergroups c ";
            if($UserLevel<USER_ADMIN){
                $query.="WHERE (OrgKey='".$_SESSION['Company']."') ";
            }
            $query.="order by c.GroupID";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);                
            break;
        case $DB_CMD_USERGROUPS:
            $query="select distinct c.UGID, c.UserID, c.GroupID, c.Active from usergroups c ";
            if($UserLevel<USER_ADMIN){
                $query.="JOIN (SELECT UID from Users d WHERE d.Company=\"";
                $query.= $_SESSION['Company']."\") e ON e.UID = c.UserID ";
            }
            $query.="order by c.GroupID";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_CMD_THEATER_OVERVIEW:
            $query="SELECT c.TheaterNumber, c.TheaterName, c.AuditoriumNumber, c.OutsideLimits, c.Description, c.Value,"
                ." c.Minimum, c.Maximum, c.Units, c.DateTime, c.OrgKey FROM RawData c ";
            $query.="INNER JOIN(SELECT TheaterNumber, AuditoriumNumber, OrgKey, Description, max(DateTime) dt FROM RawData ";
            $query.="WHERE (".$ThStr.")";
            if(array_key_exists('param1',$dataArray)){
                $query.="AND (DateTime > ".$dataArray['param1'] ." AND DateTime < ".$dataArray['param2'] .") ";
            }
            $query.="GROUP BY TheaterNumber, AuditoriumNumber, Description, OrgKey) ss "
                   ."on c.TheaterNumber = ss.TheaterNumber and c.AuditoriumNumber = ss.AuditoriumNumber and c.Description = ss.Description and c.DateTime = ss.dt "
                   ."ORDER BY c.AuditoriumNumber, c.TheaterNumber";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_CMD_GRAPH_DATA:
            $query = "SELECT c.value, c.datetime, c.units, c.Minimum, c.Maximum from RawData c WHERE (c.datetime > '" . $dataArray['StartDate'];
            $query.= "' AND c.datetime < '" . $dataArray['EndDate'];
            $query.= "' AND c.description = '" . $dataArray['Description'];
            $query.= "' AND c.TheaterNumber = '" . $dataArray['TheaterNumber'];
            $query.= "' AND c.AuditoriumNumber = '" . $dataArray['AuditoriumNumber'];
            $query.= "') AND (".$ThStr.") ORDER BY c.datetime";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_COLLECT_THEATER_GROUPS:
            $query = "SELECT c.TheaterName, c.TheaterNumber, c.OrgKey FROM RawData c ";
            if($UserLevel<USER_ADMIN){
                $query.=" WHERE (OrgKey='".$_SESSION['Company']."') ";
            }
            $query.="GROUP BY c.TheaterNumber, c. OrgKey ORDER BY c.TheaterNumber";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_CMD_GRAPH_DATA:
            $query = "SELECT c.value, c.datetime, c.units, c.Minimum, c.Maximum from RawData c WHERE (c.datetime > '" . $dataArray['StartDate'];
            $query.= "' AND c.datetime < '" . $dataArray['EndDate'];
            $query.= "' AND c.description = '" . $dataArray['Description'];
            $query.= "' AND c.TheaterNumber = '" . $dataArray['TheaterNumber'];
            $query.= "' AND c.AuditoriumNumber = '" . $dataArray['AuditoriumNumber'];
            $query.= "') AND (".$ThStr.") ORDER BY c.datetime";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_CMD_LSS_DATA:
            $query = "SELECT c.Hardware, c.Firmware, c.IpAddress, c.SerialNumber, c.Comments, MAX(c.DateTime) from RawData c";
            $query.=" WHERE (".$ThStr.")"; 
            if(array_key_exists('param1',$dataArray)){
                $query.=" AND (c.TheaterNumber=".$dataArray['param1']." AND c.AuditoriumNumber=".$dataArray['param2'].")";
            }
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_COLLECT_ORGKEYS:
            HasAccess(USER_MANAGER, true);
            $query = "SELECT DISTINCT c.Company FROM users c "; 
            if($UserLevel === USER_MANAGER){
                $query.="WHERE c.Company=\"".$_SESSION['Company']."\" ";
                $query.="AND TRIM(c.Company) > '' ";
            }else{
                // Trim empty strings and nulls
                $query.=" WHERE TRIM(c.Company) > '' ";
            }
            $query.="ORDER BY c.Company";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_CMD_NOTIFICATIONS:
            $Uemail = $_SESSION['Email'];
            $query = "SELECT RawDataId, SentDateTime, ReceivedDateTime FROM notifications "
                    ."WHERE (SentDateTime < 1";
            if(array_key_exists('param1',$dataArray)){
                $query.=" OR (SentDateTime>".$dataArray['param1']." AND SentDateTime<".$dataArray['param2'].")";
            }
            $query .= ") AND Email='".$Uemail."' ORDER BY SentDateTime";
            $result = $mysqli->query($query);
            ProcessQueryResultsRaw($result);
            break;
        case $DB_CMD_RAWDATA:
            if(count($dataArray['data'])>0){
                $query = "SELECT TheaterName,TheaterNumber,AuditoriumNumber,OutsideLimits,"
                        . "Description,Value,DateTime,Minimum,Maximum,Units FROM RawData ";
                $query.=" WHERE (".$ThStr.")";
                $count = 0;
                foreach($dataArray['data'] as $d){
                    if($count === 0){
                        $query.=" AND (id=".$d;
                    }
                    else{
                        $query.=" OR id=".$d;
                    }
                    $count=1;
                }
                $query.=")";
                $result = $mysqli->query($query);
                ProcessQueryResultsRaw($result);
            }
            break;
        case $DB_CMD_MY_GROUPS:
            $query = "SELECT GroupID from usergroups where UserID=".$_SESSION['UID'];
            $records = $mysqli->query($query);
            if($records !== null)
            {   
                $groups = array();
                if($records->num_rows > 0) {
                    while($row = $records->fetch_assoc()) {
                        $query = "SELECT u.GID, u.PID, u.GroupName, u.OrgKey FROM groups u WHERE u.GID=". $row["GroupID"];
                        $thisgrp = $mysqli->query($query);
                        if($thisgrp->num_rows > 0) {
                            while($grp = $thisgrp->fetch_assoc()) {
                                $groups[] = $grp;
                            }
                        }
                        $groups = array_merge( $groups, FetchGroupTree( $row["GroupID"], $mysqli));
                    }
                }
                $json_response = json_encode($groups);
            }
            else{ 
                $response = array();
                $response['status']  = "error";
                $response['message'] = "No theaters available.";
                // Encode the response
                $json_response = json_encode($response);
            }
            echo $json_response;
            break;
        default:
            ReturnUnknownStatus();
            break;
    }

    //-----------------------------------------------------------------------
    // ProcessQueryResultsRaw
    //
    // This will return the results without further processing.
    //-----------------------------------------------------------------------
    function ProcessQueryResultsRaw($result)
    {
        if($result == null)
        {
            $response = array();
            $response['status']  = "error";
            $response['message'] = "Failed to retrieve data, record not found.";
            // Encode the response
            $json_response = json_encode($response);
        }else{        
            $arr = array();
            if($result->num_rows > 0) {
                while($row = $result->fetch_assoc()) {
                    $arr[] = $row;	
                }
            }
            # JSON-encode the response
            $json_response = json_encode($arr);

        }
        // # Return the response
        echo $json_response;
    }
    
    //-----------------------------------------------------------------------
    // GetGoupIDs
    //
    // Takes a GroupID
    // Returns an associative array of Groups that have GroupID as a their 
    // the parent (PID).
    // ----------------------------------------------------------------------
    function FetchGroupTree($GroupID,$mysqli)
    {
        $uquery = "SELECT u.GID, u.PID, u.GroupName, u.OrgKey FROM groups u WHERE u.PID=". $GroupID;
        $children = $mysqli->query($uquery);
        $groups = array();
        if($children->num_rows > 0) {
            while($row = $children->fetch_assoc()) {
                $groups[] = $row;
                $groups = array_merge( $groups, FetchGroupTree( $row['GID'], $mysqli ) );
            }
        }
        return $groups;
    }
    //-----------------------------------------------------------------------
    // GetUsersTheaters
    //
    // Takes a userid
    // Returns an associative array of TheaterID and OrgKey that the user
    // has permissions for.
    // 
    // userid should be gotten from $userid = $_SESSION['UID']
    //-----------------------------------------------------------------------
    function GetUsersTheaters($userid,$mysqli)
    {
        $records = null;
        $uquery = "SELECT u.GroupID FROM usergroups u WHERE u.UserID=". $userid;
        $records = $mysqli->query($uquery);
        if($records !== null){   
            $groups = array();
            if($records->num_rows > 0) {
                while($row = $records->fetch_assoc()) { $groups=array_merge( $groups, FetchGroupIDs($row["GroupID"],$mysqli));	}
            }
        }
        $results = array();
        foreach ($groups as $GID) {
            $uquery = "SELECT t.TheaterNumber, t.OrgKey FROM theatergroups t WHERE t.GroupID=".strval($GID);
            $records = $mysqli->query($uquery);
            if($records->num_rows > 0) {
                while($row = $records->fetch_assoc()) { $results[] = $row; }
            }
        }
        return $results;
    }
    //-----------------------------------------------------------------------
    // GetGoupIDs
    //
    // Takes a GroupID
    // Returns an array of GroupID that include the one sent and any others
    // that point to it as a parent.
    // 
    //-----------------------------------------------------------------------
    function FetchGroupIDs($GroupID,$mysqli)
    {
        $uquery = "SELECT u.GID FROM groups u WHERE u.PID=". $GroupID .";";
        $children = $mysqli->query($uquery);
        $groups = array();
        $groups[] = $GroupID;
        if($children !== null)
        {   
            if($children->num_rows > 0) {
                while($row = $children->fetch_assoc()) {
                    $groups = array_merge( $groups, FetchGroupIDs($row["GID"],$mysqli));	
                }
            }
        }
        return $groups;
    }
    //------------------------------------------------------------------------
    // Create a search string for SQL from a TheaterNumber-OrgKey pair array
    //
    // Takes an associative array of Orgkey and TheaterNumber pairs.
    // Returns a string of the "WHERE" search to isolate those theaters in a
    // MYSQL query.
    //
    function QueryFromPairs($allowedTh)
    {
        $searchstr = "";
        foreach($allowedTh as &$th){
            if(strlen($searchstr) > 1){
                $searchstr.=" OR ";
            }
            $searchstr.="(OrgKey='".$th['OrgKey']."' AND TheaterNumber=".$th['TheaterNumber'].")";
        }
        return $searchstr;
    }
    
    //-----------------------------------------------------------------------
    // ReturnUnknownStatus
    //
    // Complete the transaction and returned a status.
    //-----------------------------------------------------------------------
    function ReturnUnknownStatus()
    {
        $cmdResponse = array('status' => "UNKNOWN");
        $json_commandResponse = json_encode($cmdResponse);
        echo $json_commandResponse;        
    }
?>
