//---------------------------------------------------------------------------
// allDataListSharedFactory
//
// The factory service is used here for sharing data between controllers.
// In this case we are sharing a list object that is returned. In the 
// controller to make use of this shared object we just do an assignment
// to the view's reference such as $scope.myList = allDatalistSharedFactory.
//---------------------------------------------------------------------------
app.factory('allDataListSharedFactory', function(){
  return list = [];  
});

// For groups
app.factory('allGroupListSharedFactory', function(){
  return glist = [];  
});

// For Theater Groups
app.factory('allTheaterGroupListSharedFactory', function(){
  return tglist = [];  
});

// For User Groups
app.factory('allUserGroupListSharedFactory', function(){
  return uglist = [];  
});

// For Screens data controller
app.factory('allScreensSharedFactory', function(){
  return screenlist = [];  
});

app.factory('getParametersFactory', function (){
  return getParameters = {
      description:'',
      screen:'',
      theater:''
  };
});

// For User Groups
app.factory('configurationFactory', function(){
  return configuration = {
      ChartDateFormat: '%m-%d-%Y',
      DateFormat: 'EEE MMMM dd, yyyy',
      TimeFormat: " 'at' h:mmaZ",
      DateRange: 2592000000,
      chartSettings: {
            chart: {
                type: 'lineChart',
                margin : {
                    top: 20,
                    right: 20,
                    bottom: 40,
                    left: 65
                },
                x: function(d){ return d.x; },
                y: function(d){ return d.y; },
                useInteractiveGuideline: true,
                dispatch: {
                    
                },
                callback: function(chart){
                }
            },
            title: {
                enable: false,
                text: 'LSS Data'
            },
            subtitle: {
                enable: true,
                text: '',
                css: {
                    'text-align': 'center',
                    'margin': '10px 13px 0px 7px'
                }
            },
            caption: {
                enable: false,
                html: '',
                css: {
                    'text-align': 'justify',
                    'margin': '10px 13px 0px 7px'
                }
            }
        }
  };  
});