//---------------------------------------------------------------------------
// mailService
// 
// Send mail service, the mailItem is an EmailMessageStruct object that
// contains address and message body text to be emailed. 
//---------------------------------------------------------------------------
app.service('mailService', function ($http, Data) {

    // A generic server side php service update request.
    this.send = function (mailItem) {
        
        var cmdData = JSON.stringify(mailItem);
        $http.post('serverservices/mail.php', cmdData).success(function(results){
            Data.toast(results);
        }).error(function(results){
            Data.toast(results);
        });

    };
    
    this.getSettings = function (mailSettings){
        // Create the command type.
        var jsonCmdObj = {"command":EnumMailSettingCmds.GET};
        // Create the stinge that sent with the post.
        var cmd = JSON.stringify(jsonCmdObj);
        // Send server request
        $http.post('serverservices/mailSettings.php', cmd).success(function(data){
            if(data.status === 'error')
                Data.toast(data);
            else
            {   
                if(data.length > 0)
                {
                    // Convert the int value to boolean type
                    if(parseInt(data[0].SMTPAuth)>0)
                        mailSettings.SMTPAuth = true;
                    else
                        mailSettings.SMTPAuth = false;
                    
                    mailSettings.ServerType = parseInt(data[0].ServerType);
                    mailSettings.SMTPSecure = data[0].SMTPSecure;
                    mailSettings.HostName   = data[0].Hostname;
                    mailSettings.Port       = parseInt(data[0].Port);
                    mailSettings.Username   = data[0].UserName;
                    mailSettings.Password   = data[0].Password;
                    mailSettings.Valid      = true;
                };
                
            };
        }).error(function(results){
            Data.toast(results);
        });
    };
    
    this.setSettings = function (mailSettings) {
        // Create the command type.
        var jsonCmdObj = {"command":EnumMailSettingCmds.SET};
       
        var cmdAndData = JSON.stringify(jsonCmdObj);
        var cmdData = JSON.stringify(mailSettings);
        // Trim the command  and data strings to append.
        cmdData = cmdData.substr(1);
        cmdAndData = cmdAndData.substr(0, cmdAndData.length-1);
        cmdAndData += ','+cmdData;
        // Send server request
        $http.post('serverservices/mailSettings.php', cmdAndData).success(function(results){
            Data.toast(results);
        }).error(function(results){
            Data.toast(results);
        });
    };
    
});

